package xyz.veronie.bgg.ui.parts;


import javax.annotation.PostConstruct;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.core.runtime.jobs.ProgressProvider;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;

import xyz.veronie.bgg.ui.helpers.CommonControls;
import xyz.veronie.bgg.ui.result.DownloadProgressMonitor;

public class DownloadThingDetailsPart {

	private DownloadProgressMonitor monitor;
	private Button extendedInfoCheck;
	private Button downloadAllPlaysCheck;

	@PostConstruct
	public void createControls(Composite parent) {
		Composite main = new Composite(parent, SWT.FILL);
		main.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		
		GridLayout layout = new GridLayout(2, false);
		main.setLayout(layout);
		
		Composite loadGamesComposite = new Composite(main, SWT.FILL);
		loadGamesComposite.setLayout(new GridLayout(1, false));
		loadGamesComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		loadGamesComposite.setBackground(main.getDisplay().getSystemColor(SWT.COLOR_WHITE));
		createLoadGamesControls(loadGamesComposite);
		
		Composite loadOptionsComposite = new Composite(main, SWT.FILL);
		loadOptionsComposite.setLayout(new GridLayout(1, false));
		loadOptionsComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		loadOptionsComposite.setBackground(main.getDisplay().getSystemColor(SWT.COLOR_WHITE));
		createLoadOptionsControls(loadOptionsComposite);

		Composite runNanDeckComposite = new Composite(main, SWT.FILL);
		runNanDeckComposite.setLayout(new GridLayout(1, false));
		runNanDeckComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false));
		runNanDeckComposite.setBackground(main.getDisplay().getSystemColor(SWT.COLOR_WHITE));
		createRunNanDeckControls(runNanDeckComposite);
		
		Composite nanDeckOptionsComposite = new Composite(main, SWT.FILL);
		nanDeckOptionsComposite.setLayout(new GridLayout(1, false));
		nanDeckOptionsComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false));
		nanDeckOptionsComposite.setBackground(main.getDisplay().getSystemColor(SWT.COLOR_WHITE));
		createNandeckOptionsControl(nanDeckOptionsComposite);
		
	}

	private void createNandeckOptionsControl(Composite compo) {
		// Combo with ("Wait for user input", "Create PDF", "Print on default printer", "Save BMP images", 
		// "Save JPG images", "Save PNG images", Save GIF images", "Save GIFa images");
		
	}

	private void createLoadOptionsControls(Composite compo) {
		Group optionsGroup = new Group(compo, SWT.SHADOW_ETCHED_IN);
		GridLayout layout = new GridLayout(3, false);
		layout.horizontalSpacing = 15;				
		optionsGroup.setLayout(layout);
		optionsGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false));
		optionsGroup.setText("Download options");
		
		Label gamesLbl = new Label(optionsGroup, SWT.LEFT);
		gamesLbl.setText("Games");
		ComboViewer gamesCombo = new ComboViewer(optionsGroup);
		CommonControls.makeEmptySpace(optionsGroup, 1);

		Label resolutionLbl = new Label(optionsGroup, SWT.LEFT);
		resolutionLbl.setText("Resolution");
		ComboViewer resolutionCombo = new ComboViewer(optionsGroup);
		CommonControls.makeEmptySpace(optionsGroup, 1);
		
		Label imagesLbl = new Label(optionsGroup, SWT.LEFT);
		imagesLbl.setText("Images");
		ComboViewer imagesCombo = new ComboViewer(optionsGroup);
		CommonControls.makeEmptySpace(optionsGroup, 1);

		
		
//		Button onlyNewCheck = new Button(optionsGroup, SWT.CHECK);
//		onlyNewCheck.setText("Only new");
//		
//		Button usePersNamesCheck = new Button(optionsGroup, SWT.CHECK);
//		usePersNamesCheck.setText("Use pers. names");
//		usePersNamesCheck.setEnabled(false);
//		
//		Button only1DesignerCheck = new Button(optionsGroup, SWT.CHECK);
//		only1DesignerCheck.setText("Only one designer");
//		only1DesignerCheck.setEnabled(false);
//
//		
//		Button withDescCheck = new Button(optionsGroup, SWT.CHECK);
//		withDescCheck.setText("With description");
//		
//		Button usePersImagesCheck = new Button(optionsGroup, SWT.CHECK);
//		usePersImagesCheck.setText("Use pers. images");
//		usePersImagesCheck.setEnabled(false);
//
//		Button only1PublisherCheck = new Button(optionsGroup, SWT.CHECK);
//		only1PublisherCheck.setText("Only one publisher");
//		only1PublisherCheck.setEnabled(false);
//
//				
//		Button limitDescCheck = new Button(optionsGroup, SWT.CHECK);
//		limitDescCheck.setText("Limit description");
//		
//		Button useRecBestInfoCheck = new Button(optionsGroup, SWT.CHECK);
//		useRecBestInfoCheck.setText("Use rec./best info");
//		useRecBestInfoCheck.setEnabled(false);
//		
//		Button only1ArtistCheck = new Button(optionsGroup, SWT.CHECK);
//		only1ArtistCheck.setText("Only one artist");
//		only1ArtistCheck.setEnabled(false);
//		
//		
//		
//		Button downloadVotesCheck = new Button(optionsGroup, SWT.CHECK);
//		downloadVotesCheck.setText("Download votes");
//		downloadVotesCheck.setEnabled(false);
//		downloadVotesCheck.addSelectionListener(new SelectionAdapter() {
//		    @Override
//		    public void widgetSelected(SelectionEvent e) {
//		    	extendedInfoCheck.setEnabled(true);
//		    }
//		});
//		
//		Button brnDetailCheck = new Button(optionsGroup, SWT.CHECK);
//		brnDetailCheck.setText("B/R/N detail");
//		brnDetailCheck.setEnabled(false);
//		
//		Button reloadDataCheck = new Button(optionsGroup, SWT.CHECK);
//		reloadDataCheck.setText("Reload data");
//		reloadDataCheck.setEnabled(false);
//		
//		
//		
//		extendedInfoCheck = new Button(optionsGroup, SWT.CHECK);
//		extendedInfoCheck.setText("   Extended info");
//		extendedInfoCheck.setEnabled(false); // enabled when download votes is checked
//		
//		Button downloadPlaysCheck = new Button(optionsGroup, SWT.CHECK);
//		downloadPlaysCheck.setText("Download plays");
//		downloadPlaysCheck.setEnabled(false);
//		downloadPlaysCheck.addSelectionListener(new SelectionAdapter() {
//		    @Override
//		    public void widgetSelected(SelectionEvent e) {
//		    	downloadAllPlaysCheck.setEnabled(true);
//		    }
//		});
//		
//		Button reloadImagesCheck = new Button(optionsGroup, SWT.CHECK);
//		reloadImagesCheck.setText("Reload images");
//		reloadImagesCheck.setEnabled(false);
//		
//		
//		
//		Button downloadLangCheck = new Button(optionsGroup, SWT.CHECK);
//		downloadLangCheck.setText("Download lang.");
//		downloadLangCheck.setEnabled(false);
//		
//		downloadAllPlaysCheck = new Button(optionsGroup, SWT.CHECK);
//		downloadAllPlaysCheck.setText("   Download plays (all)");
//		downloadAllPlaysCheck.setEnabled(false); // enabled when download plays checked
//		
//		Button ReloadQRCodesCheck = new Button(optionsGroup, SWT.CHECK);
//		ReloadQRCodesCheck.setText("Reload QR codes");
//		ReloadQRCodesCheck.setEnabled(false);
//		
//		
//		Button namesImgCheck = new Button(optionsGroup, SWT.CHECK);
//		namesImgCheck.setText("Names in images");
//		namesImgCheck.setEnabled(false);
//		
//		Button useQrCodesCheck = new Button(optionsGroup, SWT.CHECK);
//		useQrCodesCheck.setText("Use QR codes");
//		useQrCodesCheck.setEnabled(false);

	}

	private void createRunNanDeckControls(Composite compo) {
		Button runNandeckBtn = new Button(compo, SWT.LEFT);
		runNandeckBtn.setText("Run nanDeck");
		runNandeckBtn.addSelectionListener(new SelectionAdapter() {
			
		});
	}

	private void createLoadGamesControls(Composite compo) {
		
		Button loadGamesBtn = new Button(compo, SWT.LEFT);
		loadGamesBtn.setText("Load games");
		loadGamesBtn.addSelectionListener(new SelectionAdapter() {
			
		});
		
		ProgressBar progressBar = new ProgressBar(compo, SWT.SMOOTH);
		progressBar.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));

	    monitor = new DownloadProgressMonitor();

	    Job.getJobManager().setProgressProvider(new ProgressProvider() {
	      @Override
	      public IProgressMonitor createMonitor(Job job) {
	        return monitor.addJob(job);
	      }
	    });
		
	}

}
